.386
.MODEL FLAT

.CODE
_run:

include         stdparas.inc                            ; PA1-PA4
include         abpstruc.inc                            ; asmBmpPara-structure


; *********************************************************************************************

asmBmpPara      EQU                                ; prg specific values
fctR            EQU                 
fctG            EQU     
fctB            EQU     

; *********************************************************************************************

GrayScale       PROC    NEAR

init:           mac     SAVE
                push    1000                            ; => stack1 = 1000
                
                mov     ebx,asmBmpPara                  ; initialize loop
                mov     esi,srcBits
                mov     edi,tgtBits
                mov     ecx,tgtWidth
                imul    ecx,tgtHeight
                
bmp_loop:       lodsd                                   ; change pixels
                xor     ebx,ebx
                mov     edx,ebx
                mov     dl,ah
                mov     bl,al
                imul    edx,fctG
                imul    ebx,fctR
                add     ebx,edx
                shr     eax,16
                mul     fctB
                add     eax,ebx
                div     stack1
                mov     ah,al
                shl     eax,8
                mov     al,ah
                stosd
                loop    bmp_loop

                stc
finish:         pop     eax
                mac     REST

GrayScale       ENDP

END _run
